diff --git a/web/pgadmin/dashboard/static/js/SystemStats/CPU.jsx b/web/pgadmin/dashboard/static/js/SystemStats/CPU.jsx
new file mode 100644
index 000000000..276034d9e
--- /dev/null
+++ b/web/pgadmin/dashboard/static/js/SystemStats/CPU.jsx
@@ -0,0 +1,377 @@
+/////////////////////////////////////////////////////////////
+//
+// pgAdmin 4 - PostgreSQL Tools
+//
+// Copyright (C) 2013 - 2023, The pgAdmin Development Team
+// This software is released under the PostgreSQL Licence
+//
+//////////////////////////////////////////////////////////////
+// eslint-disable-next-line react/display-name
+import React, { useState, useEffect, useRef, useReducer, useMemo } from 'react';
+import PgTable from 'sources/components/PgTable';
+import gettext from 'sources/gettext';
+import PropTypes from 'prop-types';
+import { makeStyles } from '@material-ui/core/styles';
+import url_for from 'sources/url_for';
+import {getGCD, getEpoch} from 'sources/utils';
+import {ChartContainer} from '../Dashboard';
+import { Grid } from '@material-ui/core';
+import { DATA_POINT_SIZE } from 'sources/chartjs';
+import StreamingChart from '../../../../static/js/components/PgChart/StreamingChart';
+import {useInterval, usePrevious} from 'sources/custom_hooks';
+import axios from 'axios';
+
+export const X_AXIS_LENGTH = 75;
+
+const useStyles = makeStyles((theme) => ({
+  autoResizer: {
+    height: '100% !important',
+    width: '100% !important',
+    background: theme.palette.grey[400],
+    padding: '7.5px',
+    overflowX: 'auto !important',
+    overflowY: 'hidden !important',
+    minHeight: '100%',
+    minWidth: '100%',
+  },
+  container: {
+    height: 'auto',
+    background: theme.palette.grey[200],
+    padding: '10px',
+    marginBottom: '30px',
+  },
+  fixedContainer: {
+    height: '577px',
+    background: theme.palette.grey[200],
+    padding: '10px',
+    marginBottom: '30px',
+  },
+  containerHeader: {
+    fontSize: '16px',
+    fontWeight: 'bold',
+    marginBottom: '5px',
+  }
+}));
+
+export function formatBytes(bytes) {
+  const units = ['B', 'KB', 'MB', 'GB', 'TB'];
+  let unitIndex = 0;
+
+  while (bytes >= 1024 && unitIndex < units.length - 1) {
+    bytes /= 1024;
+    unitIndex++;
+  }
+
+  return `${bytes.toFixed(2)} ${units[unitIndex]}`;
+}
+
+export function transformData(labels, refreshRate) {
+  const colors = ['#FF6384','#36A2EB','#FFCE56','#4BC0C0','#9966FF','#FF9F40','#8D6E63','#2196F3','#FFEB3B','#9C27B0','#00BCD4','#CDDC39'];
+  let datasets = Object.keys(labels).map((label, i)=>{
+    return {
+      label: label,
+      data: labels[label] || [],
+      borderColor: colors[i],
+      pointHitRadius: DATA_POINT_SIZE,
+    };
+  }) || [];
+
+  return {
+    datasets: datasets,
+    refreshRate: refreshRate,
+  };
+}
+
+/* URL for fetching graphs data */
+export function getStatsUrl(sid=-1, did=-1, chart_names=[]) {
+  let base_url = url_for('dashboard.system_statistics');
+  base_url += '/' + sid;
+  base_url += (did > 0) ? ('/' + did) : '';
+  base_url += '?chart_names=' + chart_names.join(',');
+
+  return base_url;
+}
+
+/* This will process incoming charts data add it the previous charts
+ * data to get the new state.
+ */
+export function statsReducer(state, action) {
+
+  if(action.reset) {
+    return action.reset;
+  }
+
+  if(!action.incoming) {
+    return state;
+  }
+
+  if(!action.counterData) {
+    action.counterData = action.incoming;
+  }
+
+  let newState = {};
+  Object.keys(action.incoming).forEach(label => {
+    if(state[label]) {
+      newState[label] = [
+        action.counter ?  action.incoming[label] - action.counterData[label] : action.incoming[label],
+        ...state[label].slice(0, X_AXIS_LENGTH-1),
+      ];
+    } else {
+      newState[label] = [
+        action.counter ?  action.incoming[label] - action.counterData[label] : action.incoming[label],
+      ];
+    }
+  });
+  return newState;
+}
+
+const chartsDefault = {
+  'cu_stats': {'User Normal': [], 'User Niced': [], 'Kernel': [], 'Idle': []},
+  'la_stats': {'1 min': [], '5 mins': [], '10 mins': [], '15 mins': []},
+  'pcu_stats': {},
+};
+
+export default function CPU({preferences, sid, did, pageVisible, enablePoll=true}) {
+  const refreshOn = useRef(null);
+  const prevPrefernces = usePrevious(preferences);
+
+  const [cpuUsageInfo, cpuUsageInfoReduce] = useReducer(statsReducer, chartsDefault['cu_stats']);
+  const [loadAvgInfo, loadAvgInfoReduce] = useReducer(statsReducer, chartsDefault['la_stats']);
+  const [processCpuUsageStats, setProcessCpuUsageStats] = useState([]);
+
+  const [, setCounterData] = useState({});
+
+  const [pollDelay, setPollDelay] = useState(5000);
+
+  const [errorMsg, setErrorMsg] = useState(null);
+  const [chartDrawnOnce, setChartDrawnOnce] = useState(false);
+
+  const tableHeader = [
+    {
+      Header: 'PID',
+      accessor: 'pid',
+      sortable: true,
+      resizable: true,
+      disableGlobalFilter: false,
+    },
+    {
+      Header: 'Name',
+      accessor: 'name',
+      sortable: true,
+      resizable: true,
+      disableGlobalFilter: false,
+    },
+    {
+      Header: 'CPU Usage',
+      accessor: 'cpu_usage',
+      sortable: true,
+      resizable: true,
+      disableGlobalFilter: false,
+    },
+  ];
+
+  useEffect(()=>{
+    let calcPollDelay = false;
+    if(prevPrefernces) {
+      if(prevPrefernces['cu_stats_refresh'] != preferences['cu_stats_refresh']) {
+        cpuUsageInfoReduce({reset: chartsDefault['cu_stats']});
+        calcPollDelay = true;
+      }
+      if(prevPrefernces['la_stats_refresh'] != preferences['la_stats_refresh']) {
+        loadAvgInfoReduce({reset: chartsDefault['la_stats']});
+        calcPollDelay = true;
+      }
+      if(prevPrefernces['pcu_stats_refresh'] != preferences['pcu_stats_refresh']) {
+        setProcessCpuUsageStats({reset: chartsDefault['pcu_stats']});
+        calcPollDelay = true;
+      }
+    } else {
+      calcPollDelay = true;
+    }
+    if(calcPollDelay) {
+      const keys = Object.keys(chartsDefault);
+      const length = keys.length;
+      if(length == 1){
+        setPollDelay(
+          preferences[keys[0]+'_refresh']*1000
+        );
+      } else {
+        setPollDelay(
+          getGCD(Object.keys(chartsDefault).map((name)=>preferences[name+'_refresh']))*1000
+        );
+      }
+    }
+  }, [preferences]);
+
+  useEffect(()=>{
+    /* Charts rendered are not visible when, the dashboard is hidden but later visible */
+    if(pageVisible && !chartDrawnOnce) {
+      setChartDrawnOnce(true);
+    }
+  }, [pageVisible]);
+
+  useInterval(()=>{
+    const currEpoch = getEpoch();
+    if(refreshOn.current === null) {
+      let tmpRef = {};
+      Object.keys(chartsDefault).forEach((name)=>{
+        tmpRef[name] = currEpoch;
+      });
+      refreshOn.current = tmpRef;
+    }
+
+    let getFor = [];
+    Object.keys(chartsDefault).forEach((name)=>{
+      if(currEpoch >= refreshOn.current[name]) {
+        getFor.push(name);
+        refreshOn.current[name] = currEpoch + preferences[name+'_refresh'];
+      }
+    });
+
+    let path = getStatsUrl(sid, did, getFor);
+    if (!pageVisible){
+      return;
+    }
+    axios.get(path)
+      .then((resp)=>{
+        let data = resp.data;
+        setErrorMsg(null);
+        if(data.hasOwnProperty('cu_stats')){
+          let new_cu_stats = {
+            'User Normal': data['cu_stats']['usermode_normal_process_percent']?data['cu_stats']['usermode_normal_process_percent']:0,
+            'User Niced': data['cu_stats']['usermode_niced_process_percent']?data['cu_stats']['usermode_niced_process_percent']:0,
+            'Kernel': data['cu_stats']['kernelmode_process_percent']?data['cu_stats']['kernelmode_process_percent']:0,
+            'Idle': data['cu_stats']['idle_mode_percent']?data['cu_stats']['idle_mode_percent']:0,
+          };
+          cpuUsageInfoReduce({incoming: new_cu_stats});
+        }
+
+        if(data.hasOwnProperty('la_stats')){
+          let new_la_stats = {
+            '1 min': data['la_stats']['load_avg_one_minute']?data['la_stats']['load_avg_one_minute']:0,
+            '5 mins': data['la_stats']['load_avg_five_minutes']?data['la_stats']['load_avg_five_minutes']:0,
+            '10 mins': data['la_stats']['load_avg_ten_minutes']?data['la_stats']['load_avg_ten_minutes']:0,
+            '15 mins': data['la_stats']['load_avg_fifteen_minutes']?data['la_stats']['load_avg_fifteen_minutes']:0,
+          };
+          loadAvgInfoReduce({incoming: new_la_stats});
+        }
+
+        if(data.hasOwnProperty('pcu_stats')){
+          let pcu_info_list = [];
+          const pcu_info_obj = data['pcu_stats'];
+          for (const key in pcu_info_obj) {
+            pcu_info_list.push({ icon: '', pid: pcu_info_obj[key]['pid'], name: pcu_info_obj[key]['name'], cpu_usage: formatBytes(pcu_info_obj[key]['cpu_usage']) });
+          }
+
+          setProcessCpuUsageStats(pcu_info_list);
+        }
+
+        setCounterData((prevCounterData)=>{
+          return {
+            ...prevCounterData,
+            ...data,
+          };
+        });
+      })
+      .catch((error)=>{
+        if(!errorMsg) {
+          cpuUsageInfoReduce({reset:chartsDefault['cu_stats']});
+          loadAvgInfoReduce({reset:chartsDefault['la_stats']});
+          setCounterData({});
+          if(error.response) {
+            if (error.response.status === 428) {
+              setErrorMsg(gettext('Please connect to the selected server to view the graph.'));
+            } else {
+              setErrorMsg(gettext('An error occurred whilst rendering the graph.'));
+            }
+          } else if(error.request) {
+            setErrorMsg(gettext('Not connected to the server or the connection to the server has been closed.'));
+            return;
+          } else {
+            console.error(error);
+          }
+        }
+      });
+  }, enablePoll ? pollDelay : -1);
+
+  return (
+    <>
+      <div data-testid='graph-poll-delay' style={{display: 'none'}}>{pollDelay}</div>
+      {chartDrawnOnce &&
+        <CPUWrapper
+          cpuUsageInfo={transformData(cpuUsageInfo, preferences['cu_stats_refresh'])}
+          loadAvgInfo={transformData(loadAvgInfo, preferences['la_stats_refresh'])}
+          processCpuUsageStats={processCpuUsageStats}
+          tableHeader={tableHeader}
+          errorMsg={errorMsg}
+          showTooltip={preferences['graph_mouse_track']}
+          showDataPoints={preferences['graph_data_points']}
+          lineBorderWidth={preferences['graph_line_border_width']}
+          isDatabase={did > 0}
+          isTest={false}
+        />
+      }
+    </>
+  );
+}
+
+CPU.propTypes = {
+  preferences: PropTypes.object.isRequired,
+  sid: PropTypes.oneOfType([PropTypes.string.isRequired, PropTypes.number.isRequired]),
+  did: PropTypes.oneOfType([PropTypes.string.isRequired, PropTypes.number.isRequired]),
+  pageVisible: PropTypes.bool,
+  enablePoll: PropTypes.bool,
+};
+
+export function CPUWrapper(props) {
+  const classes = useStyles();
+  const options = useMemo(()=>({
+    showDataPoints: props.showDataPoints,
+    showTooltip: props.showTooltip,
+    lineBorderWidth: props.lineBorderWidth,
+  }), [props.showTooltip, props.showDataPoints, props.lineBorderWidth]);
+  return (
+    <>
+      <Grid container spacing={1} className={classes.container}>
+        <Grid item md={6} sm={12}>
+          <div className={classes.containerHeader}>{gettext('CPU Usage ()')}</div>
+          <ChartContainer id='cu-graph' title={gettext('')} datasets={props.cpuUsageInfo.datasets}  errorMsg={props.errorMsg} isTest={props.isTest}>
+            <StreamingChart data={props.cpuUsageInfo} dataPointSize={DATA_POINT_SIZE} xRange={X_AXIS_LENGTH} options={options} />
+          </ChartContainer>
+        </Grid>
+        <Grid item md={6} sm={12}>
+          <div className={classes.containerHeader}>{gettext('Load Average')}</div>
+          <ChartContainer id='la-graph' title={gettext('')} datasets={props.loadAvgInfo.datasets}  errorMsg={props.errorMsg} isTest={props.isTest}>
+            <StreamingChart data={props.loadAvgInfo} dataPointSize={DATA_POINT_SIZE} xRange={X_AXIS_LENGTH} options={options} />
+          </ChartContainer>
+        </Grid>
+      </Grid>
+      <Grid container spacing={1} className={classes.fixedContainer}>
+        <PgTable
+          className={classes.autoResizer}
+          columns={props.tableHeader}
+          data={props.processCpuUsageStats}
+          msg={props.errorMsg}
+          type={'panel'}
+        ></PgTable>
+      </Grid>
+    </>
+  );
+}
+
+const propTypeStats = PropTypes.shape({
+  datasets: PropTypes.array,
+  refreshRate: PropTypes.number.isRequired,
+});
+CPUWrapper.propTypes = {
+  cpuUsageInfo: propTypeStats.isRequired,
+  loadAvgInfo: propTypeStats.isRequired,
+  processCpuUsageStats: PropTypes.array.isRequired,
+  tableHeader: PropTypes.array.isRequired,
+  errorMsg: PropTypes.string,
+  showTooltip: PropTypes.bool.isRequired,
+  showDataPoints: PropTypes.bool.isRequired,
+  lineBorderWidth: PropTypes.number.isRequired,
+  isDatabase: PropTypes.bool.isRequired,
+  isTest: PropTypes.bool,
+};
\ No newline at end of file
diff --git a/web/pgadmin/dashboard/static/js/SystemStats/Memory.jsx b/web/pgadmin/dashboard/static/js/SystemStats/Memory.jsx
new file mode 100644
index 000000000..74e8f424b
--- /dev/null
+++ b/web/pgadmin/dashboard/static/js/SystemStats/Memory.jsx
@@ -0,0 +1,372 @@
+import React, { useState, useEffect, useRef, useReducer, useMemo } from 'react';
+import PgTable from 'sources/components/PgTable';
+import gettext from 'sources/gettext';
+import PropTypes from 'prop-types';
+import { makeStyles } from '@material-ui/core/styles';
+import url_for from 'sources/url_for';
+import {getGCD, getEpoch} from 'sources/utils';
+import {ChartContainer} from '../Dashboard';
+import { Grid } from '@material-ui/core';
+import { DATA_POINT_SIZE } from 'sources/chartjs';
+import StreamingChart from '../../../../static/js/components/PgChart/StreamingChart';
+import {useInterval, usePrevious} from 'sources/custom_hooks';
+import axios from 'axios';
+
+export const X_AXIS_LENGTH = 75;
+
+const useStyles = makeStyles((theme) => ({
+  autoResizer: {
+    height: '100% !important',
+    width: '100% !important',
+    background: theme.palette.grey[400],
+    padding: '7.5px',
+    overflowX: 'auto !important',
+    overflowY: 'hidden !important',
+    minHeight: '100%',
+    minWidth: '100%',
+  },
+  container: {
+    height: 'auto',
+    background: theme.palette.grey[200],
+    padding: '10px',
+    marginBottom: '30px',
+  },
+  fixedContainer: {
+    height: '577px',
+    background: theme.palette.grey[200],
+    padding: '10px',
+    marginBottom: '30px',
+  },
+  containerHeader: {
+    fontSize: '16px',
+    fontWeight: 'bold',
+    marginBottom: '5px',
+  }
+}));
+
+export function formatBytes(bytes) {
+  const units = ['B', 'KB', 'MB', 'GB', 'TB'];
+  let unitIndex = 0;
+
+  while (bytes >= 1024 && unitIndex < units.length - 1) {
+    bytes /= 1024;
+    unitIndex++;
+  }
+
+  return `${bytes.toFixed(2)} ${units[unitIndex]}`;
+}
+
+export function transformData(labels, refreshRate) {
+  const colors = ['#FF6384','#36A2EB','#FFCE56','#4BC0C0','#9966FF','#FF9F40','#8D6E63','#2196F3','#FFEB3B','#9C27B0','#00BCD4','#CDDC39'];
+  let datasets = Object.keys(labels).map((label, i)=>{
+    return {
+      label: label,
+      data: labels[label] || [],
+      borderColor: colors[i],
+      pointHitRadius: DATA_POINT_SIZE,
+    };
+  }) || [];
+
+  return {
+    datasets: datasets,
+    refreshRate: refreshRate,
+  };
+}
+
+/* URL for fetching graphs data */
+export function getStatsUrl(sid=-1, did=-1, chart_names=[]) {
+  let base_url = url_for('dashboard.system_statistics');
+  base_url += '/' + sid;
+  base_url += (did > 0) ? ('/' + did) : '';
+  base_url += '?chart_names=' + chart_names.join(',');
+
+  return base_url;
+}
+
+/* This will process incoming charts data add it the previous charts
+ * data to get the new state.
+ */
+export function statsReducer(state, action) {
+
+  if(action.reset) {
+    return action.reset;
+  }
+
+  if(!action.incoming) {
+    return state;
+  }
+
+  if(!action.counterData) {
+    action.counterData = action.incoming;
+  }
+
+  let newState = {};
+  Object.keys(action.incoming).forEach(label => {
+    if(state[label]) {
+      newState[label] = [
+        action.counter ?  action.incoming[label] - action.counterData[label] : action.incoming[label],
+        ...state[label].slice(0, X_AXIS_LENGTH-1),
+      ];
+    } else {
+      newState[label] = [
+        action.counter ?  action.incoming[label] - action.counterData[label] : action.incoming[label],
+      ];
+    }
+  });
+  return newState;
+}
+
+const chartsDefault = {
+  'm_stats': {'Total': [], 'Used': [], 'Free': []},
+  'sm_stats': {'Total': [], 'Used': [], 'Free': []},
+  'pmu_stats': {},
+};
+
+export default function Memory({preferences, sid, did, pageVisible, enablePoll=true}) {
+  const refreshOn = useRef(null);
+  const prevPrefernces = usePrevious(preferences);
+
+  const [memoryUsageInfo, memoryUsageInfoReduce] = useReducer(statsReducer, chartsDefault['m_stats']);
+  const [swapMemoryUsageInfo, swapMemoryUsageInfoReduce] = useReducer(statsReducer, chartsDefault['sm_stats']);
+  const [processMemoryUsageStats, setProcessMemoryUsageStats] = useState([]);
+
+  const [, setCounterData] = useState({});
+
+  const [pollDelay, setPollDelay] = useState(5000);
+  const [errorMsg, setErrorMsg] = useState(null);
+  const [chartDrawnOnce, setChartDrawnOnce] = useState(false);
+
+  const tableHeader = [
+    {
+      Header: 'PID',
+      accessor: 'pid',
+      sortable: true,
+      resizable: true,
+      disableGlobalFilter: false,
+    },
+    {
+      Header: 'Name',
+      accessor: 'name',
+      sortable: true,
+      resizable: true,
+      disableGlobalFilter: false,
+    },
+    {
+      Header: 'Memory Usage',
+      accessor: 'memory_usage',
+      sortable: true,
+      resizable: true,
+      disableGlobalFilter: false,
+    },
+    {
+      Header: 'Memory Bytes',
+      accessor: 'memory_bytes',
+      sortable: true,
+      resizable: true,
+      disableGlobalFilter: false,
+    },
+  ];
+
+  useEffect(()=>{
+    let calcPollDelay = false;
+    if(prevPrefernces) {
+      if(prevPrefernces['m_stats_refresh'] != preferences['m_stats_refresh']) {
+        memoryUsageInfoReduce({reset: chartsDefault['m_stats']});
+        calcPollDelay = true;
+      }
+      if(prevPrefernces['sm_stats_refresh'] != preferences['sm_stats_refresh']) {
+        swapMemoryUsageInfoReduce({reset: chartsDefault['sm_stats']});
+        calcPollDelay = true;
+      }
+      if(prevPrefernces['pmu_stats_refresh'] != preferences['pmu_stats_refresh']) {
+        setProcessMemoryUsageStats({reset: chartsDefault['pmu_stats']});
+        calcPollDelay = true;
+      }
+    } else {
+      calcPollDelay = true;
+    }
+    if(calcPollDelay) {
+      const keys = Object.keys(chartsDefault);
+      const length = keys.length;
+      if(length == 1){
+        setPollDelay(
+          preferences[keys[0]+'_refresh']*1000
+        );
+      } else {
+        setPollDelay(
+          getGCD(Object.keys(chartsDefault).map((name)=>preferences[name+'_refresh']))*1000
+        );
+      }
+    }
+  }, [preferences]);
+
+  useEffect(()=>{
+    /* Charts rendered are not visible when, the dashboard is hidden but later visible */
+    if(pageVisible && !chartDrawnOnce) {
+      setChartDrawnOnce(true);
+    }
+  }, [pageVisible]);
+
+  useInterval(()=>{
+    const currEpoch = getEpoch();
+    if(refreshOn.current === null) {
+      let tmpRef = {};
+      Object.keys(chartsDefault).forEach((name)=>{
+        tmpRef[name] = currEpoch;
+      });
+      refreshOn.current = tmpRef;
+    }
+
+    let getFor = [];
+    Object.keys(chartsDefault).forEach((name)=>{
+      if(currEpoch >= refreshOn.current[name]) {
+        getFor.push(name);
+        refreshOn.current[name] = currEpoch + preferences[name+'_refresh'];
+      }
+    });
+
+    let path = getStatsUrl(sid, did, getFor);
+    if (!pageVisible){
+      return;
+    }
+    axios.get(path)
+      .then((resp)=>{
+        let data = resp.data;
+        setErrorMsg(null);
+        if(data.hasOwnProperty('m_stats')){
+          let new_m_stats = {
+            'Total': data['m_stats']['total_memory']?data['m_stats']['total_memory']:0,
+            'Used': data['m_stats']['used_memory']?data['m_stats']['used_memory']:0,
+            'Free': data['m_stats']['free_memory']?data['m_stats']['free_memory']:0,
+          };
+          memoryUsageInfoReduce({incoming: new_m_stats});
+        }
+
+        if(data.hasOwnProperty('sm_stats')){
+          let new_sm_stats = {
+            'Total': data['sm_stats']['swap_total']?data['sm_stats']['swap_total']:0,
+            'Used': data['sm_stats']['swap_used']?data['sm_stats']['swap_used']:0,
+            'Free': data['sm_stats']['swap_free']?data['sm_stats']['swap_free']:0,
+          };
+          swapMemoryUsageInfoReduce({incoming: new_sm_stats});
+        }
+
+        if(data.hasOwnProperty('pmu_stats')){
+          let pmu_info_list = [];
+          const pmu_info_obj = data['pmu_stats'];
+          for (const key in pmu_info_obj) {
+            pmu_info_list.push({ icon: '', pid: pmu_info_obj[key]['pid'], name: pmu_info_obj[key]['name'], memory_usage: formatBytes(pmu_info_obj[key]['memory_usage']), memory_bytes: formatBytes(pmu_info_obj[key]['memory_bytes']) });
+          }
+
+          setProcessMemoryUsageStats(pmu_info_list);
+        }
+
+        setCounterData((prevCounterData)=>{
+          return {
+            ...prevCounterData,
+            ...data,
+          };
+        });
+      })
+      .catch((error)=>{
+        if(!errorMsg) {
+          memoryUsageInfoReduce({reset:chartsDefault['m_stats']});
+          swapMemoryUsageInfoReduce({reset:chartsDefault['sm_stats']});
+          setCounterData({});
+          if(error.response) {
+            if (error.response.status === 428) {
+              setErrorMsg(gettext('Please connect to the selected server to view the graph.'));
+            } else {
+              setErrorMsg(gettext('An error occurred whilst rendering the graph.'));
+            }
+          } else if(error.request) {
+            setErrorMsg(gettext('Not connected to the server or the connection to the server has been closed.'));
+            return;
+          } else {
+            console.error(error);
+          }
+        }
+      });
+  }, enablePoll ? pollDelay : -1);
+  return (
+    <>
+      <div data-testid='graph-poll-delay' style={{display: 'none'}}>{pollDelay}</div>
+      {chartDrawnOnce &&
+        <MemoryWrapper
+          memoryUsageInfo={transformData(memoryUsageInfo, preferences['m_stats_refresh'])}
+          swapMemoryUsageInfo={transformData(swapMemoryUsageInfo, preferences['sm_stats_refresh'])}
+          processMemoryUsageStats={processMemoryUsageStats}
+          tableHeader={tableHeader}
+          errorMsg={errorMsg}
+          showTooltip={preferences['graph_mouse_track']}
+          showDataPoints={preferences['graph_data_points']}
+          lineBorderWidth={preferences['graph_line_border_width']}
+          isDatabase={did > 0}
+          isTest={false}
+        />
+      }
+    </>
+  );
+}
+
+Memory.propTypes = {
+  preferences: PropTypes.object.isRequired,
+  sid: PropTypes.oneOfType([PropTypes.string.isRequired, PropTypes.number.isRequired]),
+  did: PropTypes.oneOfType([PropTypes.string.isRequired, PropTypes.number.isRequired]),
+  pageVisible: PropTypes.bool,
+  enablePoll: PropTypes.bool,
+};
+
+export function MemoryWrapper(props) {
+  const classes = useStyles();
+  const options = useMemo(()=>({
+    showDataPoints: props.showDataPoints,
+    showTooltip: props.showTooltip,
+    lineBorderWidth: props.lineBorderWidth,
+  }), [props.showTooltip, props.showDataPoints, props.lineBorderWidth]);
+
+  return (
+    <>
+      <Grid container spacing={1} className={classes.container}>
+        <Grid item md={6} sm={12}>
+          <div className={classes.containerHeader}>{gettext('Memory')}</div>
+          <ChartContainer id='m-graph' title={gettext('')} datasets={props.memoryUsageInfo.datasets}  errorMsg={props.errorMsg} isTest={props.isTest}>
+            <StreamingChart data={props.memoryUsageInfo} dataPointSize={DATA_POINT_SIZE} xRange={X_AXIS_LENGTH} options={options} />
+          </ChartContainer>
+        </Grid>
+        <Grid item md={6} sm={12}>
+          <div className={classes.containerHeader}>{gettext('Swap Memory')}</div>
+          <ChartContainer id='sm-graph' title={gettext('')} datasets={props.swapMemoryUsageInfo.datasets}  errorMsg={props.errorMsg} isTest={props.isTest}>
+            <StreamingChart data={props.swapMemoryUsageInfo} dataPointSize={DATA_POINT_SIZE} xRange={X_AXIS_LENGTH} options={options} />
+          </ChartContainer>
+        </Grid>
+      </Grid>
+      <Grid container spacing={1} className={classes.fixedContainer}>
+        <PgTable
+          className={classes.autoResizer}
+          columns={props.tableHeader}
+          data={props.processMemoryUsageStats}
+          msg={props.errorMsg}
+          type={'panel'}
+        ></PgTable>
+      </Grid>
+    </>
+  );
+}
+
+const propTypeStats = PropTypes.shape({
+  datasets: PropTypes.array,
+  refreshRate: PropTypes.number.isRequired,
+});
+MemoryWrapper.propTypes = {
+  memoryUsageInfo: propTypeStats.isRequired,
+  swapMemoryUsageInfo: propTypeStats.isRequired,
+  processMemoryUsageStats: PropTypes.array.isRequired,
+  tableHeader: PropTypes.array.isRequired,
+  errorMsg: PropTypes.string,
+  showTooltip: PropTypes.bool.isRequired,
+  showDataPoints: PropTypes.bool.isRequired,
+  lineBorderWidth: PropTypes.number.isRequired,
+  isDatabase: PropTypes.bool.isRequired,
+  isTest: PropTypes.bool,
+};
\ No newline at end of file
